<?php
/**
 * @version xtc3 - $Date: 2012-05-02 11:54:03 +0200 (Wed, 02 May 2012) $
 * @author Payment Network AG (integration@payment-network.com)
 * @link http://www.payment-network.com/
 *
 * @link http://www.xt-commerce.com
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 ***********************************************************************************
 * this file contains code based on:
 * (c) 2000 - 2001 The Exchange Project
 * (c) 2001 - 2003 osCommerce, Open Source E-Commerce Solutions
 * (c) 2003	 nextcommerce (account_history_info.php,v 1.17 2003/08/17); www.nextcommerce.org
 * (c) 2003 - 2006 XT-Commerce
 * Released under the GNU General Public License
 ***********************************************************************************
 *
 * $Id: sofort_lastschrift.php 3998 2012-05-02 09:54:03Z rotsch $
 *
 */

//include language-constants used in all Multipay Projects
require_once 'sofort_general.php';

define('MODULE_PAYMENT_SOFORT_LS_TEXT_TITLE', 'Lastschrift by sofort <br /><img src="https://images.sofort.com/en/ls/logo_90x30.png" alt="logo direct debit"/>');
define('MODULE_PAYMENT_SOFORT_LASTSCHRIFT_TEXT_TITLE', 'Lastschrift/Bankeinzug (direct debit by sofort)');
define('MODULE_PAYMENT_SOFORT_LS_TEXT_ERROR_MESSAGE', 'Payment is unfortunately not possible or has been cancelled by the customer. Please select another payment method.');
define('MODULE_PAYMENT_SOFORT_LS_CHECKOUT_TEXT', '');
define('MODULE_PAYMENT_SOFORT_LS_STATUS_TITLE', 'sort sequence');
define('MODULE_PAYMENT_SOFORT_LS_STATUS_DESC', 'Activate sofort.de module');
define('MODULE_PAYMENT_SOFORT_LS_SORT_ORDER_TITLE', 'sort sequence');
define('MODULE_PAYMENT_SOFORT_LS_SORT_ORDER_DESC', 'sort sequence');
define('MODULE_PAYMENT_SOFORT_LS_TEXT_DESCRIPTION', 'Payment module for Lastschrift by sofort');
define('MODULE_PAYMENT_SOFORT_LS_TEXT_ERROR_HEADING', 'Error while processing the order.');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_XML_FAULT_LS', 'Payment is unfortunately not possible or has been cancelled by the customer. Please select another payment method.');

define('MODULE_PAYMENT_SOFORT_LS_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGE', '');
define('MODULE_PAYMENT_SOFORT_LS_TEXT_HOLDER', 'account holder: ');
define('MODULE_PAYMENT_SOFORT_LS_TEXT_ACCOUNT_NUMBER', 'account number: ');
define('MODULE_PAYMENT_SOFORT_LS_TEXT_BANK_CODE', 'bank code: ');
define('MODULE_PAYMENT_SOFORT_LS_CHECKOUT_CONDITIONS', '<a onclick="javascript:window.open(\'http://documents.sofort.com/de/ls/privacy_de\',\'privacy policy\',\'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=800, height=500\');" >I have read the Privacy Policy.</a>');
define('MODULE_PAYMENT_SOFORT_LS_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGEALT', 'Payment with Lastschrift by sofort: TV certified data privacy. No additional registration. Fast delivery of goods and services.');
define('MODULE_PAYMENT_SOFORT_LASTSCHRIFT_ALLOWED_TITLE', 'Allowed zones');
define('MODULE_PAYMENT_SOFORT_LASTSCHRIFT_ALLOWED_DESC', 'Please enter <b>einzeln</b> the zones, which should be allowed for this module. (eg allow AT, DE (if empty, all zones))');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_SOFORTUEBERWEISUNG_TITLE', 'Activates/deactivates the complete module');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_SOFORTUEBERWEISUNG_DESC', 'Activates/deactivates the complete module');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_PROJECT_ID_TITLE', 'project ID');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_PROJECT_ID_DESC', 'Project number assigned by Payment Network');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY_TITLE', 'Assigned configuration key by Payment Network');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_APIKEY_DESC', 'Assigned configuration key by Payment Network');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_SORT_ORDER_TITLE', 'sort sequence');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_SORT_ORDER_DESC', 'sort sequence');
define('MODULE_PAYMENT_SOFORT_LS_ZONE_TITLE', MODULE_PAYMENT_SOFORT_MULTIPAY_ZONE_TITLE);
define('MODULE_PAYMENT_SOFORT_LS_ZONE_DESC', MODULE_PAYMENT_SOFORT_MULTIPAY_ZONE_DESC);
define('MODULE_PAYMENT_SOFORT_MULTIPAY_REASON_1_TITLE', 'Reason 1');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_REASON_1_DESC', 'For purpose 1 the following options can be selected');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_TEXT_REASON_2_TITLE', 'Reason 2');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_TEXT_REASON_2_DESC', 'shop.xtc3.reason_2_desc');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_IMAGE_TITLE', 'logo+text');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_IMAGE_DESC', 'Banner or text in the selection of payment methods');

define('MODULE_PAYMENT_SOFORT_LS_ORDER_STATUS_ID_TITLE', 'Confirmed order status');
define('MODULE_PAYMENT_SOFORT_LS_ORDER_STATUS_ID_DESC', 'Confirmed Order <br /> Order after payment.');
define('MODULE_PAYMENT_SOFORT_LS_TMP_STATUS_ID_TITLE', 'Temporary order status');
define('MODULE_PAYMENT_SOFORT_LS_TMP_STATUS_ID_DESC', 'Order status for non-completed transactions. The order has been created but the transaction has not yet been confirmed by Payment Network AG. Is also used for payment problems (eg no payment received / return debit)');

define('MODULE_PAYMENT_SOFORT_LS_TMP_COMMENT', 'Payment method direct debit by sofort chosen. Transaction not finished.');

define('MODULE_PAYMENT_SOFORT_LS_LOGO', 'logo_155x50.png');
define('MODULE_PAYMENT_SOFORT_LS_BANNER', 'banner_300x100.png');

define('MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT_TITLE', 'recommend payment method');
define('MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT_DESC', 'recommend payment method');
define('MODULE_PAYMENT_SOFORT_LS_RECOMMENDED_PAYMENT_TEXT', '(recommend payment method)');

?>