<?php
/**
 * @version xtc3 - $Date: 2012-05-02 11:54:03 +0200 (Wed, 02 May 2012) $
 * @author Payment Network AG (integration@payment-network.com)
 * @link http://www.payment-network.com/
 *
 * @link http://www.xt-commerce.com
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 ***********************************************************************************
 * this file contains code based on:
 * (c) 2000 - 2001 The Exchange Project
 * (c) 2001 - 2003 osCommerce, Open Source E-Commerce Solutions
 * (c) 2003	 nextcommerce (account_history_info.php,v 1.17 2003/08/17); www.nextcommerce.org
 * (c) 2003 - 2006 XT-Commerce
 * Released under the GNU General Public License
 ***********************************************************************************
 *
 * $Id: sofort_sofortrechnung.php 3998 2012-05-02 09:54:03Z rotsch $
 *
 */


//include language-constants used in all Multipay Projects
require_once 'sofort_general.php';

define('MODULE_PAYMENT_SOFORT_SR_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGE', '');
define('MODULE_PAYMENT_SOFORT_SR_CHECKOUT_CONDITIONS', '<a onclick="javascript:window.open(\'http://documents.sofort.com/de/sr/privacy_de\',\'privacy policy\',\'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=800, height=500\');" >I have read the Privacy Policy.</a>');

define('MODULE_PAYMENT_SOFORT_SR_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGEALT', 'checkout.sr.description');

define('MODULE_PAYMENT_SOFORT_SR_TEXT_TITLE', 'Rechnung by sofort <br /><img src="https://images.sofort.com/en/sr/logo_90x30.png"  alt="Logo Rechnung by sofort"/>');
define('MODULE_PAYMENT_SOFORT_SOFORTRECHNUNG_TEXT_TITLE', 'Kauf auf Rechnung (Purchase on account)');
define('MODULE_PAYMENT_SOFORT_SR_TEXT_ERROR_MESSAGE', 'Payment is unfortunately not possible or has been cancelled by the customer. Please select another payment method.');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_XML_FAULT_SR', 'Payment is unfortunately not possible or has been cancelled by the customer. Please select another payment method.');

define('MODULE_PAYMENT_SOFORT_MULTIPAY_SR_CHECKOUT_TEXT', '');
define('MODULE_PAYMENT_SOFORT_MULTIPAY_CONFIRM_SR', 'Acknowledge this invoice:');
define('MODULE_PAYMENT_SOFORT_SR_STATUS_TITLE', 'activate module');
define('MODULE_PAYMENT_SOFORT_SR_STATUS_DESC', 'Activates/deactivates the complete module');
define('MODULE_PAYMENT_SOFORT_SR_SORT_ORDER_TITLE', 'sort sequence');
define('MODULE_PAYMENT_SOFORT_SR_SORT_ORDER_DESC', 'Order of display. Smallest number will show first.');
define('MODULE_PAYMENT_SOFORT_SR_TEXT_DESCRIPTION', 'Buy on account with consumer protection');
define('MODULE_PAYMENT_SOFORT_SOFORTRECHNUNG_ALLOWED_TITLE', 'Allowed zones');
define('MODULE_PAYMENT_SOFORT_SOFORTRECHNUNG_ALLOWED_DESC', 'Please enter <b>einzeln</b> the zones, which should be allowed for this module. (eg allow AT, DE (if empty, all zones))');
define('MODULE_PAYMENT_SOFORT_SR_ZONE_TITLE', MODULE_PAYMENT_SOFORT_MULTIPAY_ZONE_TITLE);
define('MODULE_PAYMENT_SOFORT_SR_ZONE_DESC', MODULE_PAYMENT_SOFORT_MULTIPAY_ZONE_DESC);
define('MODULE_PAYMENT_SOFORT_SR_ORDER_STATUS_ID_TITLE', 'Confirmed order status');
define('MODULE_PAYMENT_SOFORT_SR_ORDER_STATUS_ID_DESC', 'Order status after the successful and confirmed transaction and approval of invoice by the retailer.');
define('MODULE_PAYMENT_SOFORT_SR_TMP_STATUS_ID_TITLE', 'Temporary order status');
define('MODULE_PAYMENT_SOFORT_SR_TMP_STATUS_ID_DESC', 'Order state for non-completed transactions. The order has been created but the transaction has not yet been confirmed by Payment Network AG.');
define('MODULE_PAYMENT_SOFORT_SR_CANCEL_STATUS_ID_TITLE', 'Order status at full cancelation');
define('MODULE_PAYMENT_SOFORT_SR_CANCEL_STATUS_ID_DESC', 'Canceled order status<br />Status after a full cancelation of the invoice.');

define('MODULE_PAYMENT_SOFORT_SR_TMP_COMMENT', 'Payment method Purchase on account chosen. Transaction not finished.');
define('MODULE_PAYMENT_SOFORT_SR_PENDINIG_NOT_CONFIRMED_COMMENT', 'Order with Payment by Invoice successfully submitted. The merchant is yet to acknowledge the order. Your transaction ID:');

define('MODULE_PAYMENT_SOFORT_SR_RECOMMENDED_PAYMENT_TITLE', 'recommend payment method');
define('MODULE_PAYMENT_SOFORT_SR_RECOMMENDED_PAYMENT_DESC', 'recommend payment method');
define('MODULE_PAYMENT_SOFORT_SR_RECOMMENDED_PAYMENT_TEXT', '(recommend payment method)');

define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_TIME', 'time');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_DATE', 'date');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_AMOUNT', 'Amount');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_COMMENT', 'Comment');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_ORDER_HISTORY', 'Order history');
define('MODULE_PAYMENT_SOFORT_SR_PRICE_CHANGED_CUSTOMERINFO', 'Due to the rounding of the price, a new, slightly differing invoice amount has shown. Please note this on receipt of the invoice! New invoice amount:');

/////////////////////////////////////////////////
//////// Seller-Backend and callback.php ////////
/////////////////////////////////////////////////

//Translation of words or small sentences
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_BACK', 'back'); //used for input-button
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CANCEL_INVOICE', 'cancel invoice');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CONFIRM_INVOICE', 'confirm invoice');

define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_CANCELED', 'The invoice has been cancelled');  // = loss/canceled  (canceled before confirmation)
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_CONFIRMED', 'The goods are prepared for shipping.');  // = pending/not_creditet_yet
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_PENDINIG_NOT_CONFIRMED', 'Payment method Purchase on account chosen. Transaction not finished.'); // = pending/confirm_invoice
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_CANCELED_REFUNDED', 'The invoice has been canceled. Refund created.'); // = refunded/refunded
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_CANCEL_30_DAYS', 'The invoice was cancelled. The confirmation period of 30 days has expired.'); // = loss/confirmation_period_expired

define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CURRENT_TOTAL', 'current invoice amount:');
define('MODULE_PAYMENT_SOFORT_SR_SUCCESS_ADDRESS_UPDATED', 'Delivery and invoice address updated successfully.');
define('MODULE_PAYMENT_SOFORT_SR_STATUSUPDATE_UNNECESSARY', 'status update not necessary');
define('MODULE_PAYMENT_SOFORT_SR_UNKNOWN_STATUS', 'Unknown payment/invoice status found.');

define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_DOWNLOAD_INVOICE', 'download invoice');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_DOWNLOAD_INVOICE_CREDITMEMO', 'download invoice');

define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CLOSE_WINDOW', 'close window');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CONFIRMATION_CANCEL', 'Are you really sure you want to cancel the invoice? This process can not be undone.');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_YES', 'Yes');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_NO', 'No');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_REFRESH_WINDOW', 'reload window');

define('MODULE_PAYMENT_SOFORT_SR_GLOBAL_ERROR', 'Error! Please contact the administrator.');

define('MODULE_PAYMENT_SOFORT_SR_INVOICE_CONFIRMED', 'Invoice was confirmed');
define('MODULE_PAYMENT_SOFORT_SR_INVOICE_CANCELED', 'Invoice has been canceled');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_DETAILS', 'Invoice details');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_TRANSACTION_ID', 'transaction ID');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_ORDER_NUMBER', 'order number');
define('MODULE_PAYMENT_SOFORT_SR_ADMIN_TITLE', 'Rechnung by sofort');
define('MODULE_PAYMENT_SOFORT_SR_CONFIRM_CANCEL', 'Are you really sure you want to cancel the invoice? This process can not be undone.');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_REMINDER', 'Dunning level {{d}}');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_DELCREDERE', 'Collection transfer');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CREDITED_TO_SELLER', 'Payment to the merchant account has been completed.');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CREDITED_TO_SELLER_CUSTOMER_PENDING', 'Payment to merchant account is done. Customer payment outstanding.');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CANCELED_REFUNDED', 'The invoice has been canceled. Refund created. {{time}}');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_RECEIVED', 'Received.');
define('MODULE_PAYMENT_SOFORT_SR_PENDINIG_NOT_CONFIRMED_COMMENT_ADMIN', 'Order with purchase on account successfully transmitted. Merchant confirmation not yet taken place.');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_CART_EDITED', 'The cart has been edited.');
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_CONFIRMED_SELLER', 'Transaction state: Invoice was confirmed. Waiting for payment. Invoice state: Invoice pending.');  // = pending/not_creditet_yet seller
define('MODULE_PAYMENT_SOFORT_SR_TRANSLATE_INVOICE_CANCELED_REFUNDED_SELLER', 'Transaction state: The money was refunded. Invoice state: The invoice will be refunded.'); // = refunded/refunded seller
define('MODULE_PAYMENT_SOFORT_SR_PENDING_NOT_CREDITED_YET_RECEIVED_SELLER', 'Transaction state: Invoice was confirmed. Waiting for payment. Invoice state: customer paid the receipt.');
define('MODULE_PAYMENT_SOFORT_SR_RECEIVED_CREDITED_RECEIVED_SELLER', 'Transaction state: The invoice was paid. Invoice state: customer paid the receipt.');
define('MODULE_PAYMENT_SOFORT_SR_PENDING_NOT_CREDITED_YET_REMINDER_SELLER', 'Transaction state: Invoice was confirmed. Waiting for payment. Invoice state: Dunning level {{d}}');
define('MODULE_PAYMENT_SOFORT_SR_RECEIVED_CREDITED_REMINDER_SELLER', 'Transaction state: The invoice was paid. Invoice state: Dunning level {{d}}');
define('MODULE_PAYMENT_SOFORT_SR_PENDING_NOT_CREDITED_YET_DELCREDERE_SELLER', 'Transaction state: Invoice was confirmed. Waiting for payment. Invoice state: Collection transfer');
define('MODULE_PAYMENT_SOFORT_SR_RECEIVED_CREDITED_DELCREDERE_SELLER', 'Transaction state: The invoice was paid. Invoice state: Collection transfer');
define('MODULE_PAYMENT_SOFORT_SR_RECEIVED_CREDITED_PENDING_SELLER', 'Transaction state: The invoice was paid. Invoice state: customer paid the receipt.');
